package net.java.amateras.uml.figure;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;

public class UMLClassFigure extends Figure implements EntityFigure {
	
	public static Color classColor = new Color(null, 255, 255, 206);
	
	private Label name;
	
	private CompartmentFigure attributeFigure = new CompartmentFigure();
	private CompartmentFigure methodFigure = new CompartmentFigure();

	public UMLClassFigure(Image icon) {
		this.name = new Label();
		this.name.setIcon(icon);
		
		ToolbarLayout layout = new ToolbarLayout();
		setLayoutManager(layout);
		setBorder(new LineBorder(ColorConstants.black, 1));
		setBackgroundColor(classColor);
		setOpaque(true);
		
		add(this.name);
		add(attributeFigure);
		add(methodFigure);
	}
	
	public void setFont(Font font){
		this.name.setFont(font);
	}
	
	public void setClassName(String className){
		this.name.setText(className);
	}
	
	public void add(IFigure figure, Object constraint, int index) {
		if(figure instanceof AttributeLabel){
			attributeFigure.add(figure);
		} else if(figure instanceof OperationLabel){
			methodFigure.add(figure);
		} else {
			super.add(figure,constraint,index);
		}
	}
	
	public void remove(IFigure figure) {
		if(figure instanceof  AttributeLabel){
			attributeFigure.remove(figure);
		} else if(figure instanceof OperationLabel){
			methodFigure.remove(figure);
		} else {
			super.remove(figure);
		}
	}
	
	public Label getLabel(){
		return name;
	}
	
//	public void setMethods(List methods){
//		methodFigure.removeAll();
//		for(int i=0;i<methods.size();i++){
//			Label label = new Label();
//			label.setText((String)methods.get(i));
//			label.setIcon(UMLPlugin.getImageDescriptor("icons/method.gif").createImage());
//			methodFigure.add(label);
//		}
//	}
//	
//	public void setAttributes(List attributes){
//		attributeFigure.removeAll();
//		for(int i=0;i<attributes.size();i++){
//			Label label = new Label();
//			label.setText((String)attributes.get(i));
//			label.setIcon(UMLPlugin.getImageDescriptor("icons/field.gif").createImage());
//			attributeFigure.add(label);
//		}
//	}
}
