/**
 * 
 */
package net.java.amateras.uml.sequence.model;

import java.util.Collections;
import java.util.List;

import net.java.amateras.uml.UMLPlugin;
import net.java.amateras.uml.model.AbstractUMLConnectionModel;
import net.java.amateras.uml.model.AbstractUMLEntityModel;
import net.java.amateras.uml.model.EntityModel;
import net.java.amateras.uml.properties.MessagePropertyDescriptor;

import org.eclipse.ui.views.properties.IPropertyDescriptor;

/**
 * @author Takahiro Shida.
 * 
 */
public class MessageModel extends AbstractUMLConnectionModel implements
		EntityModel {

	public static final String P_NAME = "_instance_name";

	private String name;

	public void setName(String name) {
		String oldName = this.name;
		this.name = name;
		firePropertyChange(P_NAME, oldName, name);
	}

	public String getName() {
		return this.name;
	}

	private EntityModel getType() {
		AbstractUMLEntityModel model = getTarget();
		if (model instanceof ActivationModel) {
			ActivationModel activationModel = (ActivationModel) model;
			InstanceModel owner = activationModel.getOwnerLine().getOwner();
			return owner.getType();
		}
		return null;
	}

	public List getProporsal() {
		EntityModel model = getType();
		if (model instanceof AbstractUMLEntityModel) {
			AbstractUMLEntityModel entityModel = (AbstractUMLEntityModel) model;
			return entityModel.getChildren();
		}
		return Collections.EMPTY_LIST;
	}

	public IPropertyDescriptor[] getPropertyDescriptors() {
		MessagePropertyDescriptor descriptor = new MessagePropertyDescriptor(
				P_NAME, UMLPlugin.getDefault().getResourceString(
						"property.name"));
		descriptor.setUMLModels(getProporsal());
		return new IPropertyDescriptor[] { descriptor };
	}

	public Object getPropertyValue(Object id) {
		if (id.equals(P_NAME)) {
			return getName();
		}
		return null;
	}

	public boolean isPropertySet(Object id) {
		if (id.equals(P_NAME)) {
			return true;
		}
		return false;
	}

	public void setPropertyValue(Object id, Object value) {
		if (id.equals(P_NAME)) {
			setName((String) value);
		}
	}
}
